function clickIE4(){
	if (event.button==2) return false;
}

function clickNS4(e) {
	if (document.layers||document.getElementById&&!document.all) {
		if (e.which==2||e.which==3) return false;
	}
}

if (document.layers) {
	document.captureEvents(Event.MOUSEDOWN);
	document.onmousedown=clickNS4;
}
else if (document.all&&!document.getElementById) {
	document.onmousedown=clickIE4;
}
document.oncontextmenu=new Function("return false");

var loading_txt='<div class=cssload-clock></div><div class=load-error>Вероятно, что-то пошло не так</div>';

$('body').off('click','input[type="reset"]');
$('body').on('click','input[type="reset"]', function(e){
	e.preventDefault();
	var form=$(this).closest('form');
	$(form).find('input[type="text"]').val('');
	$(form).find('input[type="hidden"]').val('');
	$(form).find('input[type="date"]').val('');
	$(form).find('input[type="number"]').val('');
	$(form).find('select').prop("selectedIndex", 0);
});

function show_window(id=null, html=loading_txt) {
	return $('body').append('<div class="popup" id="'+id+'"><div class="popup_area"><div class="close close_button"><i class="fa fa-times" aria-hidden="true"></i></div><div class="popup_content">'+html+'</div></div></div>');
}

function close_window(elem){
	var w=$(elem).closest('.popup');
	$(w).remove();
}

function load_window(link) {
	var id=$.now();
	show_window(id);
	$('#'+id+' .popup_content').load(link, function(response, status, xhr) {
  		if(status=="error") {
    		$('#'+id+' .popup_content').html(xhr.status+" "+xhr.statusText);
  		}
	});
}

$('body').on('click', '.close', function (){close_window(this)});

function close_all_window() {
	$('.popup').remove();
	if($('form[name="product_search_form"] input[name="product_search"]').length>0) {
		$('form[name="product_search_form"] input[name="product_search"]').focus();
	}
}

// Если есть ошибки синхронизации
function view_logs_n(n) {
	if(n>0) { // Если есть ошибки синхронгизации
		$('.gear').addClass('false');
		$('#logs_n').html("("+n+")");
	}
	else { // Если нет ошибок синхронизации
		$('.gear').removeClass('false');
		$('#logs_n').html("");
	}
}

// Если есть документы на фискализацию
function view_remote_receipts(n) {
	$("#remote_receipts_alarm").remove();
	if(n>0) { // Если есть документы на удаленную фискализацию
		$('.remote_receipts').show();
		$('#remote_receipts_n').html('('+n+')');
		var m=$('.remote_receipts').closest('.first_menu');
		$('a', m).eq(0).append('<span id="remote_receipts_alarm">('+n+')</span>');
	}
	else { // Если нет документов на удаленную фискализацию
		$('.remote_receipts').hide();
		$('#remote_receipts_n').html('');
	}
}

function ajax_response(response) {
	var res=JSON.parse(response);
    show_window('message', '<p class="'+res.success+'">'+res.txt+'</p>');
	if(res.next_step) {
		//show_window('loading', loading_txt);
		load_ajax(res.next_step);
	}
	if(res.reroute) {
		location.href=res.reroute;
	}

	// Если есть ошибки синхронизации
	if(res.logs_n) {
		view_logs_n(res.logs_n!=undefined);
	}
	// Если есть документы на удаленную фискализацию
	if(res.remote_receipts!=undefined) {
		view_remote_receipts(res.remote_receipts);
	}
	
	if(res.reload) {
		var elem=res.reload;
		var href=$(elem).attr('href');
		if(res.id) {
			if(href.indexOf('?')>0) {
				href+='&';
			}
			else {
				href+='?';
			}
			href+='id='+res.id;
		}
		show_window('loading', loading_txt);
		$(elem).load(href+' '+elem+' .reload', function(){
			if(res.scroll) {
				if($(res.scrollto).length>0) {
					var contactTopPosition = $(res.scrollto).position().top;
					$(res.scroll).scrollTop(contactTopPosition);
				}
			}
		});
	}
	if(res.reload_menu) {
		$('#receipt_menu').load(location.href+' #receipt_menu > .first_menu');
		$('#room_menu').load(location.href+' #room_menu > .first_menu');
	}
	if(res.close_all_window) {
		close_all_window();
	}
	if(res.form_reset) {
		$('form').trigger("reset");
	}
	if(res.function) {
		eval(res.function);
	}
}

function load_ajax(href) {
	show_window('loading', loading_txt);
	$.ajax({
        url: href,
        dataType: "html",
        success: function(response) {
        	close_all_window();
       		var isJson = true;
        	var res;
        	try {
    			res=JSON.parse(response);
			} catch(e) {
    			isJson = false;
			}
       		if(isJson) {
       			ajax_response(response);
       		}
       		else {
       			show_window(null, response);
       		}
    	},
    	error: function(response) {
            $("#loading .popup_content").html(response.statusText);
    	},
    	timeout: 65000
 	});
}

function send_form(form) {
	$('input', form).blur();
	var submit_button=$('input[type="submit"]', form);
	submit_button.attr('disabled', 'disabled');
	show_window('loading', loading_txt);
	action=$(form).attr('action');
	if(action==undefined)action='';
	var method=$(form).attr('method');
	if(method==undefined)action='GET';
	var formData = $(form).serialize();
	$.ajax({
        url: action,
        type: method,
        dataType: "html",
        data: formData,
        success: function(response) {
        	submit_button.removeAttr('disabled');
        	$("#loading").remove();
        	var isJson = true;
        	var res;
        	try {
    			res=JSON.parse(response);
			} catch(e) {
    			isJson = false;
			}
       		if(isJson) {
       			ajax_response(response);
       		}
       		else {
       			show_window(null, response);
       		}
    	},
    	error: function(response) {
    		submit_button.removeAttr('disabled');
            $("#loading .popup_content").html(response.statusText);
    	},
    	timeout: 305000
 	});
}

$('body').on('click', '.popup .pagination a', function(e){
	var href=$(this).attr('href');
	close_window(this);
	load_window(href);
	e.preventDefault();
});

$('body').on('submit', '.popup .close_window', function(){
	close_window(this);
});

$('body').on('click', '.show_window', function(e){
	var href=$(this).attr('href');
	load_window(href);
	e.preventDefault();
});

$('body').on('click', '.send_ajax', function(e){
	var href=$(this).attr('href');
	load_ajax(href);
	e.preventDefault();
});

$('body').on('click', '.gen_pass', function(){
	var input=$('input[name="'+$(this).attr('for')+'"]');
	var l=$(this).attr('length');
	if(l==undefined || l==null) {
		l=6;
	}
	var pass="";
	var words='0123456789qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM';
	var max_pos=words.length-1;
	for(i=0; i<l; i++) {
		pos=Math.floor(Math.random()*max_pos);
		pass+=words.substring(pos, pos+1);
	}
	input.val(pass);
});

$('body').on('submit', 'form:not(.no_ajax)', function(e){
	send_form(this);
	e.preventDefault();
});

// Экранная цифровая клавиатура

// Цифры
$('body').on('click', '.virtual_key', function(){
	var sel = window.getSelection()+'';
	var el=$('.'+$(this).attr('for')).eq(0);
	if(sel.length>0) {
		el.val($(this).val());
	}
	else {
		el.val(el.val()+$(this).val());
	}
	if(!el.is(':focus')) el.focus();
});

// очистить
$('body').off('click', '.virtual_key_delete');
$('body').on('click', '.virtual_key_delete', function(){
	var el=$(this).attr('for');
	var form=$('.'+el).closest('form');
	$('input[type="text"]', form).val('');
	$('input[type="password"]', form).val('');

	$('select', form).prop('selectedIndex',0);
	$('select', form).trigger('change');
	//$(form).trigger("reset");
	//$('.'+el).focus();
	$('.'+el).val('');
});

// удалить символ
$('body').on('click', '.virtual_key_bks', function(){
	var val=$('.'+$(this).attr('for')).val();
	val=val.substr(0, val.length-1);
	$('.'+$(this).attr('for')).val(val);
	$('.'+$(this).attr('for')).focus();
});

$('body').on('submit', 'form[name="messages_continue_form"]', function(){
	close_window(this);
});

$('body').off('click', '#smile');
$('body').on('click', '#smile', function(){
	$('body').toggleClass('body_replace');
});

// Автоматическая синхронизация
function synchronization() {
	$('#synchronization_status').html('');
	var dt = new Date();
	var time = dt.getMinutes();
	if(time%synchronization_timer!=0) return;
	$('#synchronization_status').html('Идет синхронизация...');
	var l='/api/auto';
	if($('.users_list').length>0) {
		l+='?reload=1';
	}
	$.ajax({
        url: l,
        dataType: "html",
        success: function(response) {
        	var res;
        	try {
    			res=JSON.parse(response);
    			var res=JSON.parse(response);
        		$('#synchronization_status').html(res.txt);
        		setTimeout('$("#synchronization_status").html("");', 10000);
        		view_logs_n(res.logs_n);
        		view_remote_receipts(res.remote_receipts);

        		if(res.reload) {
        			var user_id=$(res.reload+' select').val();
					$(res.reload).load(location.href+' .reload', function(){
						$(res.reload+' select').val(user_id);
					});
				}
			} catch(e) {
    			$('#synchronization_status').html('');
			}
    	},
    	timeout: 65000
 	});
}

// Запускаем синхронизацию
synchronization();
setInterval('synchronization()', 60000);

// Управляем полным экраном
function exit_fullscreen() {
	if(document.cancelFullScreen) {
    	document.cancelFullScreen();
  	}
  	else if(document.mozCancelFullScreen) {
    	document.mozCancelFullScreen();
  	}
  	else if(document.webkitCancelFullScreen) {
    	document.webkitCancelFullScreen();
  	}
}

function fullscreen() {
	var element=document.documentElement;
	if(element.requestFullScreen) {
    	element.requestFullScreen();
  	}
  	else if(element.mozRequestFullScreen) {
    	element.mozRequestFullScreen();
  	}
  	else if(element.webkitRequestFullScreen) {
    	element.webkitRequestFullScreen();
  	}
}

function toggle_fullscreen() {
	var full=document.fullscreenElement;
	if(full==null) {
		fullscreen();
	}
	else {
		exit_fullscreen();
	}
}

$('body').off('click', '#fullscreen');
$('body').on('click', '#fullscreen', function(){
	toggle_fullscreen();
});

function auto_fullscreen() {
	if((location.pathname=='/receipts/sales' || location.pathname=='/') && $('input[name="auto_fullscreen"]').val()==1) {
		fullscreen();
	}
	else {
		clearInterval(auto_fs);
		return;
	}

	var full=document.fullscreenElement;
	if(full!=null) {
		clearInterval(auto_fs);
	}
}

var auto_fs=setInterval("auto_fullscreen()", 3000);

var auto_close;

function auto_logout_function() {
	auto_logout_timer++;
	if(auto_logout_timer==auto_logout) {
		load_ajax('/users/logout');
	}
}

var auto_logout_timer=0;
if(auto_logout>0) {
	$('body').keypress(function(){
		auto_logout_timer=0;
	});
	$('body').mousemove(function(){
		auto_logout_timer=0;
	});
	setInterval(auto_logout_function, 1000);
}

function auto_remote_fiscalization_function() {
	if($('#remote_receipts_n').html()=='') {
		auto_remote_fiscalization_timer=0;
		return;
	}
	auto_remote_fiscalization_timer++;
	var a=auto_remote_fiscalization-auto_remote_fiscalization_timer;
	$('#countdown').remove();
	if(a>0 && a<=5) {
		var html='<h1>Сейчас что-то произойдет...</h1><p align="center"><big>'+a+'</big></p>';
		show_window('countdown', html);
	}

	if(auto_remote_fiscalization_timer==auto_remote_fiscalization) {
		var href=$('.remote_receipts').attr('href')+'?close=1';
		load_ajax(href);
	}
}

var auto_remote_fiscalization_timer=0;
if(auto_remote_fiscalization>0) {
	$('body').keypress(function(){
		auto_remote_fiscalization_timer=0;
	});
	$('body').mousemove(function(){
		auto_remote_fiscalization_timer=0;
	});
	setInterval(auto_remote_fiscalization_function, 1000);
}

$('body').keydown(function(e){
	if(e.which==112) { // F1
		e.preventDefault();
		location.href='/receipts/sales';
		return;
	}

	if(e.which==113) { // F2
		e.preventDefault();
		location.href='/receipts/return';
		return;
	}

	if(e.which==114) { // F3
		e.preventDefault();
		location.href='/receipts/search';
		return;
	}

	if(e.which==117) { // F6
		e.preventDefault();
		location.href='/receipts/cashin';
		return;
	}

	if(e.which==118) { // F7
		e.preventDefault();
		location.href='/receipts/cashout';
		return;
	}

	if(e.which==119) { // F8
		e.preventDefault();
		location.href='/receipts/reports';
		return;
	}

    if(e.which == 27) { // Нажатие Esc
        // Находим последнее окно
        var n=$('.popup').length;
        var w=$('.popup').eq(n-1);
        // Проверяем можно ли закрывать это окно
        if($('.close_button', w).length>0) {
        	w.remove(); // Закрываем окно
        }
    }
});


var isCtrl = false;
$(document).keyup(function (e) {
	if(e.which == 17) isCtrl=false;
}).keydown(function (e) {
	if(e.which == 17) isCtrl=true;
	if(e.which == 81 && isCtrl == true) {
		close_all_window();
		$('body').toggleClass('qwerty');
	}
});

$('body').off('click', '.first_menu');
$('body').on('click', '.first_menu', function() {
	$(this).trigger('hover');
});
